{-

  Autores: 
          Adelmario Douglas Leite Cabral Junior adlcj
          Carlos Eduardo Albuquerque da Cunha ceac
          Francisco de Farias Dantas
          Pedro Lages de Menezes

  Instrues para executar o os programas nesta implementao de Imp2 em Haskell:

  A funo principal chamanda exec (exec :: Comando -> String) recebe um Comando como entrada e fornece uma String de
  sada. Um Comando  um tipo de dado que contem a estrutura do programa que queremos executar. Este comando deve ser
  estruturado da forma com que foi definida a sintaxe de Imp2 (logo abaixo).
  O contedo da String de saida ser a sequncia de valores impressos no programa atravs do write.
  Ex: Caso sejam impressos "Aprendendo Haskell" e a string "hello world" serah exibido : "Aprendendo Haskell" , "hello world"

  Para executar os programas de teste: (Ao final do arquivo foram gerados e programas teste)

  Para fazer os testes deve-se executar a funo run seguida do Comando (programa) que se deseja testar.
  Ex.: exec exp1
       exec exp2
       exec exp3
       exec exp4
-}

{- Sintaxe de Imp2 -}

type Programa = Comando

data Comando = PAtrib Idt Expressao           -- Atribuicao ::= Id "=" Expressao
             | PComdDecl Declaracao Comando   -- ComandoDeclaracao ::= "{" Declaracao ";" Comando "}"
             | PWhile Expressao Comando       -- While ::= "while" Expressao "do" Comando
             | PIf Expressao Comando Comando  -- IfThenElse ::= "if" Expressao "then" Comando "else" Comando
             | PIO Cio                        -- IO
             | PComdSqt Comando Comando       -- Comando ";" Comando
             | PSkip                          -- Skip ::= "skip"
             | PChmProc Idt ListaExpressao    -- ChamadaProcedimento ::= "call" Id "(" ListaExpressao ")"
             deriving Show

data Cio = PIOw Expressao  -- IO ::= "write" "(" Expressao ")"
        | PIOr Idt        -- IO ::= "read" "(" Id ")"
        deriving Show

data Expressao = PVl Valor
               |  ExpUnaria
               | PExpBinaria ExpBinaria
               | PId Idt
               deriving Show

data Valor = PVlInt Int
           | PVlString String
           | PVlBool Bool
           | FUNCAO (ListaDecPar, Comando)
	   | PErro
 	   deriving Show

data ExpUnaria = PNegacao Expressao -- "-" Expressao
               | PNot Expressao     -- "not" Expressao
               | PLength Expressao  -- "length" Expressao
               deriving Show

data ExpBinaria = PSoma Expressao Expressao          -- Expressao "+" Expressao
                | PSubtracao Expressao Expressao     -- Expressao "-" Expressao
                | PAnd Expressao Expressao           -- Expressao "and" Expressao
                | POr Expressao Expressao            -- Expressao "or" Expressao
                | PIgualS Expressao Expressao        -- Expressao "==" Expressao aqui para strings
                | PIgualI Expressao Expressao        -- Expressao "==" Expressao aqui para inteiros
                | PConcatenacao Expressao Expressao  --Expressao "++" Expressao
                deriving Show

data ListaDecPar = PListDec Tipo Idt                 -- Tipo Ident
                 | PMultListDec Tipo Idt ListaDecPar -- Tipo Id "," ListaDeclaracaoParametro
                 deriving Show

data Idt = PIdent String
           deriving Show

data Tipo = PString  -- "String"
          | PInt     -- "Int"
          | PBool    -- "Boolean"
          deriving Show

data Declaracao = PDecVar Idt Expressao             -- DeclaracaoVariavel ::= "var" Id "=" Expressao
                | PDecProc Idt ListaDecPar Comando  -- DeclaracaoProcedimento ::= "proc" Id "(" [ListaDeclaracaoParametro] ")" "{" Comando "}"
                | PMultDec Declaracao Declaracao    -- Declaracao "," Declaracao
                deriving Show

data ListaExpressao = PExpressao Expressao               -- Expressao
                    | PMultExpressao Expressao ListaExpressao -- Expressao "," ListaExpressao
                    deriving Show


type Data = (Idt, Valor) -- estrutura criada para ligar identificadores a seus repsctivos valores
type Memory = [Data]     -- estrutura criada para armazenar todos os dados
type Saida = String      -- estrutura criada para armazenar o valor de saida do programa
type BufferReader = Valor  -- estrutura de dados que armazenarah

--------------------------------------------------------------------------------------------------------------------------PAREI AQUI!!!
{- funcoes para avaliar declaracoes, guarda-las e remove-las na/da memoria. Funcoes de ajuda -}

avlDec :: Declaracao -> Memory -> Memory
avlDec (PDecVar i e) m = addDec (i , avlExpressao e m) m -- caso declaracaod de variavel
avlDec (PDecProc i l c) m = addDec (i, FUNCAO(l,c)) m      -- caso declaracao de procedimentos
avlDec (PMultDec d d1) m = avlDec d1 (avlDec d m)        -- caso multiplas declaracoes

addDec :: Data -> Memory -> Memory
addDec d m | (existe d m) == True = m
           | otherwise = (d : m)

remDec :: Idt -> Memory -> Memory
remDec i [] = []
remDec (PIdent i) ( (PIdent i1, v) : m) | i == i1 = m
                                        | otherwise = ( (PIdent i1, v) : remDec (PIdent i) m)

existe :: Data -> Memory -> Bool
existe _ [] = False
existe (PIdent i, v) ( (PIdent i1, v1) : m) | i == i1 = True
                                            | otherwise = ( existe (PIdent i, v) m)

{- funcao para mudar valores de bindings na memoria -}

altValor :: Idt -> Valor -> Memory -> Memory
altValor _ _ [] = []
altValor (PIdent i) v ((PIdent i1, v1) : m) | i == i1 = ((PIdent i1,v):m)
                                            | otherwise = ( (PIdent i1,v1) : (altValor (PIdent i) v m))

{- funcao para recuperar valor de variaveis na memoria -}

getValor :: Idt -> Memory -> Valor
getValor (PIdent i) ((PIdent i1, v) : m) | i == i1 = v
                                         | otherwise = (getValor (PIdent i) m)
getValor _ [] = PErro

{- funcoes para retorno de valores concretos -}

getInt :: Valor -> Int
getInt (PVlInt i) = i

getString :: Valor -> String
getString (PVlString s) = s

getBool :: Valor -> Bool
getBool (PVlBool b) = b

getTipo :: Valor -> String
getTipo (PVlString s) = "String"
getTipo (PVlInt i) = "Int"
getTipo (PVlBool b) = "Bool"

getTtipo :: Tipo -> String
getTtipo (PString) = "String"
getTtipo (PInt) = "Int"
getTtipo (PBool) = "Bool"

{- funcoes para avaliar expressoes -}

avlExpressao :: Expressao -> Memory -> Valor

-- CASO IDENTIFICADORES
avlExpressao (PId i) m = getValor i m

-- CASO VALORES
avlExpressao (PVl (PVlInt i)) m = (PVlInt i)
avlExpressao (PVl (PVlString s)) m = (PVlString s)
avlExpressao (PVl (PVlBool b)) m = (PVlBool b)

-- CASO EXPRESSAO UNARIA
avlExpressao (PExpUnaria (PNegacao e)) m = PVlInt ( - ( getInt (avlExpressao e m) ) )
avlExpressao (PExpUnaria (PNot e)) m = PVlBool ( not ( getBool (avlExpressao e m) ) )
avlExpressao (PExpUnaria (PLength e)) m = PVlInt ( length ( getString (avlExpressao e m) ) )

-- CASO EXPRESSAO BINARIA
avlExpressao (PExpBinaria (PSoma a b)) m = PVlInt ((getInt (avlExpressao a m)) + (getInt (avlExpressao b m)))
avlExpressao (PExpBinaria (PSubtracao a b)) m = PVlInt ((getInt (avlExpressao a m)) - (getInt (avlExpressao b m)))
avlExpressao (PExpBinaria (PAnd a b )) m = PVlBool ((getBool (avlExpressao a m)) && (getBool (avlExpressao b m)))
avlExpressao (PExpBinaria (POr a b)) m = PVlBool ((getBool (avlExpressao a m)) || (getBool (avlExpressao b m)))
avlExpressao (PExpBinaria (PConcatenacao a b)) m = PVlString ((getString (avlExpressao a m)) ++ (getString (avlExpressao b m)))
avlExpressao (PExpBinaria (PIgualS a b)) m = PVlBool ((getString (avlExpressao a m)) == (getString (avlExpressao b m)))
avlExpressao (PExpBinaria (PIgualI a b)) m = PVlBool ((getInt (avlExpressao a m)) == (getInt (avlExpressao b m)))

{- funcoes para avaliacao de comandos -}
avlComando :: Comando -> Memory -> Saida -> BufferReader -> (Memory , Saida, BufferReader)

avlComando (PAtrib i e) m s b = ((altValor i (avlExpressao e m)  m) , s, b)                      -- PAtrib Idt Expressao



avlComando (PComdDecl d c) m s b = avlComando c (avlDec d m) s b                            -- PComdDecl Declaracao Comando

avlComando (PWhile e c) m s b | getBool (avlExpressao e m ) == False = (m,s,b)               -- PWhile Expressao Comando
                              | otherwise = let
                                             (m1,s1,b1) = (avlComando c m s b)
                                          in
                                             (avlComando (PWhile e c) m1 s1 b1)

avlComando (PIf e c1 c2) m s b | getBool (avlExpressao e m) == True = (avlComando c1 m s b)  -- PIf Expressao Comando Comando
                               | otherwise = (avlComando c2 m s b)

avlComando (PComdSqt c1 c2) m s b = let                                                    -- PComdSqt Comando Comando
                                    (m1,s1,b1) = (avlComando c1 m s b)
                                  in
                                    avlComando c2 m1 s1 b1

avlComando (PSkip) m s b = (m,s,b) -- PSkip

avlComando (PIO (PIOr i)) m s b = ((altValor i (getValorBuffer b) m),s,b)                  -- PIOr Idt

avlComando (PIO (PIOw e)) m s b = (m , concatenaResposta (avlExpressao e m) s , b)         -- PIOw Expressao

avlComando (PChmProc i le) m s b = let
                                      FUNCAO (l,c) = getValor i m
                                   in
                                      let
                                        m1 = clrParMem l le m
                                      in
                                        let
                                          (m2, s2, b2) = avlComando c m1 s b
                                        in
                                          remParMem l m2 s2 b2


-- abaixo segue a funcoes que auxilia a avaliacao do comando de read

getValorBuffer :: BufferReader -> Valor
getValorBuffer b = b

-- abaixo segue as funcoes que auxiliam a avaliacao do comando write

concatenaResposta :: Valor -> String -> Saida
concatenaResposta v s = (s ++ " , " ++ (getStringValor v))

getStringValor :: Valor -> String
getStringValor (PVlInt i) = show i
getStringValor (PVlBool b) = show b
getStringValor (PVlString s) = show s

-- abaixo seguem as funcoes que auxiliam a avaliacao do comando de chamada de procedimento
clrParMem :: ListaDecPar -> ListaExpressao -> Memory -> Memory
clrParMem (PListDec t i) (PExpressao e) m | ( (getTtipo t) == (getTipo (avlExpressao e m))) == True = ((i, avlExpressao e m) : m)
                                          | otherwise = m
clrParMem (PMultListDec t i ldp) (PMultExpressao e mle) m = clrParMem ldp mle (clrParMem (PListDec t i) (PExpressao e) m)

remParMem :: ListaDecPar -> Memory -> Saida -> BufferReader -> (Memory, Saida, BufferReader)
remParMem (PListDec t i) (m : m1) s b = (m1,s,b)
remParMem (PMultListDec t i ldp) (m : m1) s b = remParMem ldp m1 s b

exec :: Comando -> String
exec c = let (m,s,b) = (avlComando c [] "" (PVlInt 0))
         in pegaSaida s

pegaSaida :: Saida -> String
pegaSaida s = s

-- abaixo seguem exeplos de codigos para utilizar o Imp2

{-
        write("hello world")
-}
exp1 :: Comando
exp1 = (PComdSqt
        (PSkip)                                         -- Skip ; write("Hello world!!")
        (PIO(PIOw(PVl(PVlString "hello world!!"))))
      )

{-
  {
    var x = 5;
    while(!(x==0)){
      write(x);
      x = x - 1;
    }
    write("Feliz Ano Novo!!!")

  }

-}

exp2 :: Comando
exp2 = (PComdDecl
        (PDecVar (PIdent "x") (PVl(PVlInt 5)))                                  -- var x = 2
        (PComdSqt
          (PWhile                                                                     -- abre while(not (x==0))
            (PExpUnaria(PNot(PExpBinaria(PIgualI (PVl(PVlInt 0)) (PId(PIdent "x"))))))
            (PComdSqt
              (PIO(PIOw(PId(PIdent "x"))))                                            -- write(x)
              (PAtrib
                (PIdent "x")                                                          -- x = x - 1
                (PExpBinaria(PSubtracao(PId(PIdent "x")) (PVl(PVlInt 1))))
              )
            )
          )
          (PIO(PIOw(PVl(PVlString "Feliz Ano Novo!!!"))))                    -- write("Feliz Ano Novo!!!")
        )
      )

{-
  if (not (2==3))
  then write(true)
  else write(false)
-}
exp3 :: Comando
exp3 = (PIf
        (PExpUnaria(PNot(PExpBinaria(PIgualI (PVl(PVlInt 2)) (PVl(PVlInt 3))))))
        (PIO(PIOw(PVl(PVlBool True))))
        (PIO(PIOw(PVl(PVlBool False))))
      )

{-
   var x = 5,
   var y = 7,
   var resposta = false,
   proc maior (int a, int b){
     if (a==b)then reposta = true
     else resposta = false
   };
   write(resposta);
-}
exp4 :: Comando
exp4 = (PComdDecl
        (PMultDec
          (PDecVar(PIdent "x") (PVl(PVlInt 5)))                       -- var x = 5
          (PMultDec
            (PDecVar(PIdent "y") (PVl(PVlInt 7)))                     -- var y = 7
            (PMultDec
              (PDecVar(PIdent "resposta") (PVl(PVlBool False)))       -- var resposta = False
              (PDecProc
                (PIdent "maior")                                       -- abre proc maior(int a, int b)
                (PMultListDec
                  (PInt)
                  (PIdent "a")
                  (PListDec
                    (PInt)
                    (PIdent "b")
                  )
                )
                (PIf                                                         -- if a== b
                  (PExpBinaria(PIgualI(PId(PIdent "a"))(PId(PIdent "b"))))
                  (PAtrib
                    (PIdent "resposta")                                      -- then resposta = True
                    (PVl(PVlBool True))
                  )
                  (PAtrib
                    (PIdent "resposta")                                      -- else resposta = False
                    (PVl(PVlBool False))
                  )
                )
              )                                                         -- fecha proc maior(int a, int b)
            )
          )
        )
        (PComdSqt
          (PChmProc
            (PIdent "maior")
            (PMultExpressao
              (PId(PIdent "x"))
              (PExpressao(PId(PIdent "y")))
            )
          )
          (PIO(PIOw(PId(PIdent "resposta"))))
        )
      )


